Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class UntypedAtomicConverter

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.UnaryExpression
              net.sf.saxon.expr.UntypedAtomicConverter

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, SequenceIterable, InstructionInfo, org.xml.sax.Locator

    public final class UntypedAtomicConverter

extends UnaryExpression

An UntypedAtomicConverter is an expression that converts any untypedAtomic items in a sequence to a specified type

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.UnaryExpression
`operand`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, staticProperties`

Constructor Summary
`UntypedAtomicConverter(Expression sequence, AtomicType requiredItemType, boolean allConverted)` Constructor

Method Summary
`boolean` | `areAllItemsConverted()` Determine whether all items are to be converted, or only the subset that are untypedAtomic
`int` | `computeCardinality()` Determine the static cardinality.
`int` | `computeSpecialProperties()` Determine the special properties of this expression
`Expression` | `copy()` Copy an expression.
`protected java.lang.String` | `displayOperator(Configuration config)` Give a string representation of the operator for use in diagnostics
`Item` | `evaluateItem(XPathContext context)` Evaluate as an Item.
`void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the items returned by the expression
`ItemType` | `getRequiredItemType()` Get the item type to which untyped atomic items must be converted
`SequenceIterator` | `iterate(XPathContext context)` Iterate over the sequence of values
`Expression` | `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.UnaryExpression
`displayExpressionName, equals, getBaseExpression, hashCode, iterateSubExpressions, optimize, promote, replaceSubExpression, simplify, toString`

Methods inherited from class net.sf.saxon.expr.Expression
`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, display, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluatePendingUpdates, explain, findParentOf, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isUpdatingExpression, iterateEvents, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### UntypedAtomicConverter

    public UntypedAtomicConverter(Expression sequence,
                                  AtomicType requiredItemType,
                                  boolean allConverted)

  Constructor

  Parameters:
    `sequence` - this must be a sequence of atomic values. This is not checked; a ClassCastException will occur if the precondition is not satisfied.
    `requiredItemType` - the item type to which untypedAtomic items in the sequence should be converted, using the rules for "cast as".
    `allConverted` - true if the result of this expression is a sequence in which all items belong to the required type

Method Detail

### getRequiredItemType

    public ItemType getRequiredItemType()

  Get the item type to which untyped atomic items must be converted

  Returns:
    the required item type

### areAllItemsConverted

    public boolean areAllItemsConverted()

  Determine whether all items are to be converted, or only the subset that are untypedAtomic

  Returns:
    true if all items are to be converted

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by the expression

  Overrides:
    `getItemType` in class `UnaryExpression`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the item type of the items in the result sequence, insofar as this is known statically.

### computeCardinality

    public int computeCardinality()

  Description copied from class: `UnaryExpression`
  Determine the static cardinality. Default implementation returns the cardinality of the operand

  Overrides:
    `computeCardinality` in class `UnaryExpression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `UnaryExpression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### computeSpecialProperties

    public int computeSpecialProperties()

  Determine the special properties of this expression

  Overrides:
    `computeSpecialProperties` in class `UnaryExpression`
  Returns:
    `StaticProperty.NON_CREATIVE`.

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate over the sequence of values

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate as an Item. This should only be called if the UntypedAtomicConverter has cardinality zero-or-one

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Overrides:
    `explain` in class `UnaryExpression`
  Parameters:
    `out` - the expression presenter used to display the structure

### displayOperator

    protected java.lang.String displayOperator(Configuration config)

  Description copied from class: `UnaryExpression`
  Give a string representation of the operator for use in diagnostics

  Overrides:
    `displayOperator` in class `UnaryExpression`
  Returns:
    the operator, as a string

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) Saxonica Limited. All rights reserved.